       include 'sizes'
      implicit double precision (a-h,o-z) 
      dimension  rx(mnrec),ry(mnrec),irecid(mnrec)
      dimension itsnap(mtsnap),iwsnap(mwsnap),irx(mnrec),iry(mnrec)
      dimension tsnap(mtsnap),wsnap(mwsnap)
            
      integer blockid,vblockid,blockty
      common/a1/ncontrol,blockid,vblockid(2),blockty,nsx,nsy 
                
      real*8 kf1(10),kf2(10),rof1(10),rof2(10),muf1(10),muf2(10)
      real*8 xks1(10),xks2(10),ros1(10),ros2(10),phi1(10),phi2(10)
      real*8 perm1(10),perm2(10),qsm1(10),qsm2(10),qkc1(10),qkc2(10)
      real*8 qm1(10),qm2(10)
      integer esp1(10),esp2(10)
      real*8 xkm1(10),xkm2(10),xnw1(10),xnw2(10)
      integer nc1,nc2,vector(mngy+1)
c
c  global matrix matnum 
c 
c  matnum : integer matrix containing  the material type number at
c            each grid block in the global mesh
c
      dimension matnum(0:mngx+1,0:mngy+1)
c     tmp - serial code
c      blockid=mynode()
       blockid=0


       call      readata(freq,key,stime,nx,ny,ngx,ngy,h,ntsnap,
     1              matnum,jsou,ksou,nrec,irx,iry,isourid,irecid,
     1              kdel,nwsnap,maxiter,reduc,nsize,hpx,hpy,
     1              wsnap,tsnap,maxlow,npf,f1,f2,f3,f4,perclow,
     1              xsou,ysou,rx,ry,fq1,fq2,keym,vmin,veloc1,
     1              kf1,kf2,rof1,rof2,muf1,muf2,xks1,xks2,ros1,ros2,
     1              phi1,phi2,perm1,perm2,qsm1,qsm2,qkc1,qkc2,qm1,
     1              qm2,esp1,esp2,nc1,nc2,xkm1,xkm2,xnw1,xnw2,
     1              np1,np2)
c23456
        

       
     
       

       call laminar(ysize,h,nc1,nc2,esp1,esp2,ny,ngy,np1,np2,vector)
        

         

     
      call     asignacion(kf1,kf2,rof1,rof2,muf1,muf2,  
     1                    xks1,xks2,ros1,ros2,phi1,phi2,
     1                    perm1,perm2,qsm1,qsm2,         
     1                    qkc1,qkc2,qm1,qm2,xkm1,xkm2,
     1                    xnw1,xnw2,vector,ngx,ngy)   

       stop
       end                       
      
**********************************************************************
       subroutine     readata(freq,key,stime,nx,ny,ngx,ngy,h,ntsnap,
     1              matnum,jsou,ksou,nrec,irx,iry,isourid,irecid,
     1              kdel,nwsnap,maxiter,reduc,nsize,hpx,hpy,
     1              wsnap,tsnap,maxlow,npf,f1,f2,f3,f4,perclow,
     1              xsou,ysou,rx,ry,fq1,fq2,keym,vmin,veloc1,
     1              kf1,kf2,rof1,rof2,muf1,muf2,xks1,xks2,ros1,ros2,
     1              phi1,phi2,perm1,perm2,qsm1,qsm2,qkc1,qkc2,qm1,
     1              qm2,esp1,esp2,nc1,nc2,xkm1,xkm2,xnw1,xnw2,
     1              np1,np2)


   




       include 'sizes'
       
      implicit double precision (a-h,o-z)

      dimension  irecid(mnrec)
      dimension rx(mnrec), ry(mnrec),irx(mnrec), iry(mnrec)
      dimension  wsnap(mwsnap),tsnap(mtsnap)
      integer nrec
      integer blockid,vblockid,blockty
       real*8 kf1(10),kf2(10),rof1(10),rof2(10),muf1(10),muf2(10)
      real*8 xks1(10),xks2(10),ros1(10),ros2(10),phi1(10),phi2(10)
      real*8 perm1(10),perm2(10),qsm1(10),qsm2(10),qkc1(10),qkc2(10)
      real*8 qm1(10),qm2(10),h
      integer esp1(10),esp2(10)
      real*8 xkm1(10),xkm2(10),xnw1(10),xnw2(10)
      integer nc1,nc2,np1,np2

      common/a1/ncontrol,blockid,vblockid(2),blockty,nsx,nsy
      

c
c  global matrix matnum 
c 
c  matnum : integer matrix containing  the material type number at
c            each grid block in the global mesh
c
      dimension matnum(0:mngx+1,0:mngy+1)
c
c   end  dimension statements
c
      
c
c  reads   nsx = number of processors ( blocks) in the x-direccion
c
c
c  reads   nsy = number of processors ( blocks) in the y-direccion
c
c  ncontrol = processor number where output is being written
c
c
c  reads   ngx = global grid size in the  x-direccion
c
c
c  reads   ngy = global grid size in the  y-direccion
c

       read(5,170)maxlow
       read(5,150)perclow
       read(5,170)nsx
       read(5,170)nsy
       read(5,170)ncontrol
       read(5,170)ngx
       read(5,170)ngy

c     compute local grid sizes
      nx = ngx/nsx
      ny = ngy/nsy

      if(blockid.eq.ncontrol) then
      write(6,1831) nsx,nsy
1831  format(/1x,'# subdomains  in x-direction nsx = ',i5,/,
     $       1x,'# subdomains  in y-direction nsy = ',i5)
      write(6,2831) ncontrol
2831  format(/1x,'# control subdomain ncontrol = ',i5)

      write(6,3831) ngx,ngy
3831  format(/1x,'global # elements  in x-direction ngx = ',i5,/,
     $       1x, 'global # elements  in y-direction ngy = ',i5)

      write(6,8831) nx,ny
 8831 format(/1x,'local # elements  in x-direction nx = ',i5,/,
     $       1x, 'local # elements  in y-direction ny = ',i5)
      endif

c     compute size of buffer for message passing
      nmax = nx
      if( nmax.lt.ny) nmax = ny
      nsize = 16*(nmax+2)*8

      if(nx.gt.mnx ) stop 77
      if(ny.gt.mny) stop 77
      read(5,150)xsize
      read(5,150) ysize
c  computes  processor grid sizes  hpx, hpy
c

           hpx = xsize/nsx
           hpy = ysize/nsy


      if(blockid.eq.ncontrol) then
 150  format(e20.8)
      write(6,8382) hpx,hpy
 8382 format(/1x,' processor grid size in the x-dir  hpx = ',g20.8,/,
     $       1x, ' processor grid size in the y-dir  hpy  = ',g20.8)

      write(6,1)xsize
 1    format(/1x,' domain size xsize = ',e20.8,' m')
      write(6,22) ysize
 22    format(/1x,' domain size ysize = ',e20.8,' m')
      endif
      if(blockid.eq.ncontrol) then
        write(6,1730)maxlow,perclow
        
1730   format(/1x,'  maxlow (max.iter. in low freq range ) = ',
     1 i6,' perclow ( perc. of(low) freq. solved with maxlow = ', 
     1 e20.8)
          endif 
c
c   chooses minimum h between hx and hy
c
         hx=xsize/ngx
         hy=ysize/ngy
         h = hx
           if(h.gt.hy)h=hy
c
c      rounds xsize , ysize
c
         xsize=ngx*h
         ysize=ngy*h
      if(blockid.eq.ncontrol) then
         write(6,66291)xsize,ysize
66291    format(/1x,' rounded xsize = ',e20.8,' m ; ',/,
     $        ' rounded ysize = ',e20.8,' m '/)
      endif
c
c
c  now when reading domain description we may have problems
c  since xsize and ysize may be smaller.
c   we may have to run twice the code  for this reason.
c the first pass just to know the rounded -to - h  sizes.
c
c
      read(5,170)nwsnap
      if(nwsnap.gt.mwsnap)stop 27453
      read(5,150)(wsnap(i),i=1,nwsnap)
      read(5,170) ntsnap
      if(ntsnap.gt.mtsnap)stop 27454      
      read(5,150) (tsnap(i),i=1,ntsnap)
      read(5,170)npf
      read(5,170)key
      read(5,150)freq
      read(5,150)stime
      read(5,150)f1
      read(5,150)f2
      read(5,150)f3
      read(5,150)f4
      read(5,170)maxiter
      read(5,150)reduc
      if(nwsnap.gt.mwsnap) stop 5183
      if(ntsnap.gt.mtsnap) stop 6183

      if(blockid.eq.ncontrol) then
      write(6,8833) h
 8833 format(/1x,' mesh size h= ',e20.8,' m')
      write(6,76234)nwsnap
76234 format(/1x,' number of snapshots in freq. domain= ',i5)
      write(6,7746)(i,wsnap(i),i=1,nwsnap)
 7746 format(/1x,' freq. to compute  snapshots in freq.domain',/,
     $     i5,3x,e20.8,' khz')
      write(6,76232)ntsnap
76232 format(/1x,' number of snapshots in time domain= ',i5)
      write(6,7741) (i,tsnap(i),i=1,ntsnap)
 7741 format(/1x,' times to compute  snapshots in time domain',/,
     $     i5,3x,e20.8,' msec')


       
87365  format(/1x,' quadrature choice=1,standard,=2,mid point',/,
     1           '  keyqua = ',i5)
      write(6,16234)npf
16234 format(/1x,' number of points to compute solution= ',/,
     1           ' in the frequency domain    npf  = ',i5)

      write(6,100)key
100   format(/1x,'  key==1 for type 1 source (tsang&rader paper) ;',
     $   /1x,'      key==2 for type 2 source(gaussian derivative)
     $      ;',i5,//)


      write(6,1305)freq
1305  format(/1x,'  frequency  freq= ',e20.8,' khz'//)
      write(6,160)stime
160   format(/1x,' total simulation time  stime =  ',e20.8,' msec'/)

         write(6,7752)f1,f2,f3,f4
 7752   format(/1x,'  parameters of  source band-pass filter',//,
     1         ' set equal to 0. if not filter is desired'//,
     1         ' f1  = ',e20.8,'   khz ',//,
     1         ' f2  = ',e20.8,'   khz ',//,
     1         ' f3  = ',e20.8,'   khz ',//,
     1         ' f4  = ',e20.8,'   khz ',//)

           write(6,2190)maxiter
2190     format(/1x,'  maxiter =  max. # inner iterations ',i5)
           write(6,2590)reduc
2590     format(/1x,'  reduc =  relative error required  ',e20.8)

       endif



      read(5,170)nmat
      if(nmat.gt.mnmat) stop 222

      if(blockid.eq.ncontrol) then
c               write(6,7923)
7923   format(/1x,' vector xnod  in readata '//)
c             write(6,34921)(xnod(j),j=1,nx+1)
34921  format(/1x,5e15.5)
c               write(6,1923)
1923   format(/1x,' vector ynod  in readata '//)
c             write(6,34921)(ynod(j),j=1,ny+1)

      write(6,2346)nmat
2346   format(/1x,' number of materials (nmat) = ',i5)

       read(5,170)kdel

       write(6,9473)kdel
9473   format(/1x,' kdel=0 : delta, kdel = 1:  d/dx(delta). kdel = ',i6)
      endif

c
c  if source is derivative of delta, checks that the source position
c  xsou  does no coincide with a nodal  point  xnod(k)
c
c
c  reads  global physical position of  point source
c
       
      read(5,*)xsou
      read(5,*)ysou
      if(xsou.lt.h) xsou=h
      if(xsou.gt.(xsize-h)) xsou=xsize-h
      if(ysou.lt.h) ysou=h
      if(ysou.gt.(ysize-h)) ysou=ysize-h 
 
      read(5,170)nrec
      if(nrec .gt. mnrec) stop 9920
c
c  gets  local grid corrdinates ( jsou,ksou) for the source
c  and sourceid  with the blockid number where the source
c  is located.
        js = xsou/hpx
         ks = ysou/hpy
          ks = (nsy-1)-ks

c gets blockid where the source is located
c
        isourid = ks*nsx + js
         souvid1 = mod(isourid,nsx)
          souvid2 = isourid/nsx

c       souvid1 *hpx = x-coordinate of the block isourid where
c                       the source is located

           xsourbl= souvid1*hpx

c        ((nsy-1)-souvid2)*hpy = y-coordinate of the  block where
c                                the source is located

              ysourbl = ((nsy-1)-souvid2)*hpy
           xsloc = xsou-xsourbl
           ysloc = ysou-ysourbl

      jsou=xsloc/h + 1.0d0
      ksou = ysloc/h + 1.0d0

      if(jsou.gt.nx.or.jsou.lt.1) then
      if (blockid.eq.ncontrol)then
       write(6,5693)jsou
5693   format(/1x,' wrong jsou = ',i5)
       endif 
       stop 666
        endif

      if(ksou.gt.ny.or.ksou.lt.1) then
      if (blockid.eq.ncontrol)then
       write(6,5697)ksou
5697   format(/1x,' wrong ksou = ',i5)
       endif 
       stop 666
        endif

      if(blockid.eq.ncontrol) then
      write(6,7725)jsou,ksou
 7725 format(/1x,' jsou = ',i5,'  ksou = ',i5)
       write(6,7722)xsou,ysou
 7722 format(/1x,' xsou = ',e20.8,' m ysou = ',e20.8,' m')

      write(6,7624) nrec
 7624 format(/1x,' number of receivers, nrec = ',i5)
       endif

c
c  reads  global physical position of receivers
c
      do 7723 i = 1, nrec
         read(5,150) rx(i)
         read(5,150) ry(i)
       if(rx(i).lt.h) rx(i)=h
       if(rx(i).gt.(xsize-h)) rx(i)=xsize-h
       if(ry(i).lt.h) ry(i)=h
       if(ry(i).gt.(ysize-h)) ry(i)=ysize-h 
c    
c  gets  local grid corrdinates ( jsou,ksou) for the source
c  and sourceid  with the blockid number where the source
c  is located.
        jr = rx(i)/hpx
         kr = ry(i)/hpy
          kr = (nsy-1)-kr

c gets blockid where the receiver is located
c
        irecid(i) = kr*nsx + jr
         recid1 = mod(irecid(i),nsx)
          recid2 = irecid(i)/nsx

c       recid1 *hpx = x-coordinate of the block irecid(i) where
c                       the actual receiver is located

           xrecbl= recid1*hpx

c        ((nsy-1)-recid2)*hpy = y-coordinate of the  block irecid(i) where
c                                the actual receiver is located

              yrecbl = ((nsy-1)-recid2)*hpy
           xrloc = rx(i)-xrecbl
           yrloc = ry(i)-yrecbl

      irx(i)=xrloc/h + 1.0d0
      iry(i) = yrloc/h + 1.0d0

      if(blockid.eq.ncontrol) then
         write(6,7727) i, irx(i), iry(i), rx(i), ry(i)
 7727 format(/1x,'receiver i =',i5,3x,'irx & iry = ',2i5,/,15x,
     $     'rx(i) & ry(i) = ', 2g15.8, '  m')
      endif

      if(irx(i).lt.1.or.irx(i).gt.nx+1)then
      if(blockid.eq.ncontrol) then
         write(6,7729) i, irx(i),nx+1
      endif
      stop  88888
      endif

 7729 format(/1x,'receiver i =',i5,3x,'irx(i)  = ',i5,
     $     'nx+1  = ',i5)

             if(iry(i).lt.1.or.iry(i).gt.ny+1)then

      if(blockid.eq.ncontrol) then
         write(6,7750) i, iry(i),ny+1
      endif

 7750 format(/1x,'receiver i =',i5,3x,' iry(i)  = ',i5,
     $     'ny+1  = ',i5)
                stop  88888

                   endif

 7723    continue
c
c      if(blockid.eq.ncontrol) then

c      do 7743 i = 1, 3

c         write(6,7836) kdel, i, irx(i)
c7836      format(/1x,' kdel -  i - irx(i) (receivers) ',3i5)
c7743    continue
c        endif
c               endif
c
c    matnum(i) = material type number for material of type  i
c
c    reads 2-d earth  material description  via  izi,izf,numat
6735   continue
       read(5,150)xi,xf,yi,yf
       read(5,170)numat
170    format(i5)
      if(blockid.eq.ncontrol) then
       write(6,3854)xi,xf,yi,yf,numat
3854   format(1x,' from  xi                     = ',e20.8,' m  ',/
     1           ' up to xf                     = ',e20.8,' m ',/  
     1           ' from  yi                     = ',e20.8,' m  ',/
     1           ' up to yf                     = ',e20.8,' m ',/  
     1           ' material type number  numat  = ',i5/)

          endif

       if(xi.lt.0.)go to 5553
c
c   adjusts xi, xf, yi and yf to indicate the mid point
c   physical  cordinates    of the initial and final grid blocks
c    having  material property  numat
c 
           xi = xi + .5d0*h
           xf = xf - .5d0*h
           
           yi = yi + .5d0*h
           yf = yf - .5d0*h

 
       ixi= xi/h + 1.0d0
       ixf= xf/h + 1.0d0
       iyi= yi/h + 1.0d0
       iyf= yf/h + 1.0d0

      if(blockid.eq.ncontrol) then

       write(6,2673)ixi,ixf,iyi,iyf,numat
2673   format(1x,' from  ixi (x-global grid #)    = ',i5,/
     1           ' up to ixf (x-global grid #)    = ',i5,/  
     1           ' from  iyi (y-global grid #)    = ',i5,/
     1           ' up to yf  (y-global grid #)    = ',i5,/  
     1           ' material type number  numat    = ',i5/)


      endif

        if(ixi.lt.1.or.ixi.gt.ngx)then
        write(6,6629)ixi
6629     format(/1x,' wrong material description  ixi = ',i5)
           stop
            endif

        if(iyi.lt.1.or.iyi.gt.ngy)then
        write(6,6129)iyi
6129     format(/1x,' wrong material description  iyi = ',i5)
           stop
            endif


        if(ixf.lt.1.or.ixf.gt.ngx)then
        write(6,6229)ixf
6229     format(/1x,' wrong material description  ixf = ',i5)
           stop
            endif

        if(iyf.lt.1.or.iyf.gt.ngy)then
        write(6,6669)iyf
6669     format(/1x,' wrong material description  iyf = ',i5)
           stop
            endif

          if(numat.lt.1.or.numat.gt.nmat)then
        write(6,8629)numat
8629     format(/1x,' wrong material number numat  = ',i5)
           stop
            endif

        do 6736 j=ixi,ixf
       do 6736 k=iyi,iyf

       matnum(j,k)=numat
6736   continue

       go to 6735
5553   continue
             do 9836 k=0,ngy+1
               matnum(0,k) = matnum(1,k)
                 matnum(ngx+1,k) = matnum(ngx,k)
9836        continue

             do 9837 j=0,ngx+1
                matnum(j,0) = matnum(j,1)
                    matnum(j,ngy+1) = matnum(j,ngy)

9837        continue

                   iii=1
                       if(iii.eq.2) then

c
c starts printing  material type number for each element (j,k)
c
       write(6,4347)
4347   format(//1x,' material information  for each  element'//)
c
c  loop  over the elements
c
       do 3429 j=1,nx
       do 3429 k=1,ny

       write(6,776)
776    format(/1x,'element    material type number'/)

       write(6,4537)j,k,matnum(j,k)
4537   format(/1x,i2,2x,i2,10x,i5)


3429   continue

                  endif


c Aqui comienzo con los parametros de las distintas capas
c       read(5,*)  
       read(5,*)nc1
       read(5,*)np1
       do i=1,nc1
       read(5,*)esp1(i)
       read(5,*)kf1(i)
      
       read(5,*)rof1(i)
       read(5,*)muf1(i)
       read(5,*)xks1(i)
       read(5,*)ros1(i)
       read(5,*)phi1(i)
       read(5,*)perm1(i)
       read(5,*)xkm1(i)
       read(5,*)xnw1(i)
       read(5,*)qsm1(i)
       read(5,*)qkc1(i)
       read(5,*)qm1(i)
       
* changes units of bulk modulus from GPa to gr-m-ms 1 GPa = 10^10 dyn/cm^2 = 10*6 gr/(m (ms)^2)

       
       kf1(i)  = kf1(i)*1.d+6 
       xks1(i) = xks1(i)*1.d+6
       xnw1(i) = xnw1(i)*1.d+6 
       xkm1(i) = xkm1(i)*1.d+6
* changes unit of mass from gr/cm^3   to gr/m^3   gr/cm^3 = 10^6 gr/m^3 

       rof1(i) = rof1(i)* 1.d+6
       ros1(i) = ros1(i)* 1.d+6
       
* changes units of viscosity from Poise to gr/(m ms) 
*  1 Poise = gr/(cm s) =10^{-1} gr/(m ms)       
       muf1(i) = muf1(i) * 1.d-1 
* changes units of permeability from cm^2  to m^2  

       perm1(i) = perm1(i) * 1.d-4
            
       enddo    
c       read(5,*)
       read(5,*)nc2
       read(5,*)np2
        do i=1,nc2
       read(5,*)esp2(i)
       read(5,*)kf2(i)
       read(5,*)rof2(i)
       read(5,*)muf2(i)
       read(5,*)xks2(i)
       read(5,*)ros2(i)
       read(5,*)phi2(i)
       read(5,*)perm2(i)
       read(5,*)xkm2(i)
       read(5,*)xnw2(i)
       read(5,*)qsm2(i)
       read(5,*)qkc2(i)
       read(5,*)qm2(i)
       
* changes units of bulk modulus from GPa to gr-m-ms 1 GPa = 10^10 dyn/cm^2 = 10*6 gr/(m (ms)^2)

       
       kf2(i)  = kf2(i)*1.d+6 
       xks2(i) = xks2(i)*1.d+6
       xnw2(i) = xnw2(i)*1.d+6 
       xkm2(i) = xkm2(i)*1.d+6
* changes unit of mass from gr/cm^3   to gr/m^3   gr/cm^3 = 10^6 gr/m^3 

       rof2(i) = rof2(i)* 1.d+6
       ros2(i) = ros2(i)* 1.d+6
       
* changes units of viscosity from Poise to gr/(m ms) 
*  1 Poise = gr/(cm s) =10^{-1} gr/(m ms)       
       muf2(i) = muf2(i) * 1.d-1 
* changes units of permeability from cm^2  to m^2  

       perm2(i) = perm2(i) * 1.d-4       
       
       enddo 
       
        
c       read(5,*)  
       read(5,2)fq1
       read(5,2)fq2
       read(5,3)keym
       read(5,2)vmin
       read(5,2)veloc1
       
       
       

2      format(g20.10)
3      format(i5)

                    return
                          end
			  
*******************************************************************************************************
			  
      subroutine  laminar(ysize,h,nc1,nc2,esp1,esp2,ny,ngy,np1,np2
     1,vector)
c Esta subrutine entrega vector, tal que vector(k) indica
c 1) si es positivo, el nodo en y nro. k esta en la 
c region 1; sino en la 2
c 2) abs(vector(k)) indica nro. de capa en la correspondiente reg.
      include 'sizes'
      real*8 ysize,h,aux1,aux2,esptot,aux3
      integer esp1(10),esp2(10)
      integer nc1,nc2,ny,vector(mngy+1),vectorb(mngy+1)
      
      
      write(6,*)
      write(6,*)' ny  ngy = ',ny,ngy
      
      


      k=0
      do i=1,np1
      do j=1,nc1
      do ij=1,esp1(j)
      k=k+1
      vector(k)=j
      enddo
      enddo
      enddo 
 
     
   
      
      do i=1,np2
      do j=1,nc2
      do ij=1,esp2(j)
      k=k+1
      vector(k)=-j
      enddo
      enddo
      enddo      


      
       
      if(k.ne.ngy) then
      write(*,*)'Hay algun problema con las capas'
      stop
      endif
      
       
      do k=1,ngy
      vectorb(k)=vector(ngy+1-k)
      enddo
      do k=1,ngy
      vector(k)=vectorb(k)
      enddo 
      return
      end

***************************************************************************************************************
      
      subroutine asignacion(kf1,kf2,rof1,rof2,muf1,muf2,  
     1                    xks1,xks2,ros1,ros2,phi1,phi2,
     1                    perm1,perm2,qsm1,qsm2,         
     1                    qkc1,qkc2,qm1,qm2,xkm1,xkm2,
     1                    xnw1,xnw2,vector,ngx,ngy)      
      

       include 'sizes'

      real*8 kf1(10),kf2(10),rof1(10),rof2(10),muf1(10),muf2(10)
      real*8 xks1(10),xks2(10),ros1(10),ros2(10),phi1(10),phi2(10)
      real*8 perm1(10),perm2(10),qsm1(10),qsm2(10),qkc1(10),qkc2(10)
      real*8 qm1(10),qm2(10),xkm1(10),xkm2(10),xnw1(10),xnw2(10)
      

      
* global data matrices
      
      real*8 kf_g(0:mngx+1,0:mngy+1),rhof_g(0:mngx+1,0:mngy+1)
      real*8 muf_g(0:mngx+1,0:mngy+1),xks_g(0:mngx+1,0:mngy+1)
      real*8 ros_g(0:mngx+1,0:mngy+1)
      real*8 fi_g(0:mngx+1,0:mngy+1),kperm_g(0:mngx+1,0:mngy+1)
      real*8 qsm_g(0:mngx+1,0:mngy+1),qkc_g(0:mngx+1,0:mngy+1)
      real*8 qm_g(0:mngx+1,0:mngy+1),xkm_m_g(0:mngx+1,0:mngy+1)
      real*8 struc_g(0:mngx+1,0:mngy+1)
      real*8 shear_mod_el_g(0:mngx+1,0:mngy+1)
            
      integer vector(mngy+1)

      

           
c global data coef. files
      
       open(unit=85,  file='kf_g.dat',    status='new')
       open(unit=86,  file='rof_g.dat',   status='new')       
       open(unit=87,  file='muf_g.dat',   status='new')
       open(unit=88,  file='xks_g.dat',   status='new')
       open(unit=89,  file='ros_g.dat',   status='new')       
       open(unit=90,  file='fi_g.dat',    status='new')
       open(unit=91,  file='kperm_g.dat', status='new')
       open(unit=92,  file='qsm_g.dat',   status='new')       
       open(unit=93,  file='qkc_g.dat',   status='new')       
       open(unit=94,  file='qm_g.dat',    status='new')
       open(unit=95,  file='xkm_g.dat',   status='new')
       open(unit=96,  file='shear_mod_el_g.dat',status='new')
       open(unit=97,  file='struc_g.dat', status='new') 
       

         if(blockid.eq.ncontrol)then
	 

	write(6,*)
        write(6,*)' ngx,ngy = ',ngx,ngy
	write(6,*)	
 
	endif	
			              
      do k=1,ngy
      nc=vector(k)
      if(nc.gt.0) then
c Estoy en la capa superior
      do j=0,ngx+1
      kf_g(j,k)=kf1(nc)
      rhof_g(j,k)=rof1(nc)
      muf_g(j,k)=muf1(nc)
      xks_g(j,k)=xks1(nc)
      ros_g(j,k)=ros1(nc)
      fi_g(j,k)=phi1(nc)
      kperm_g(j,k)=perm1(nc)
      qsm_g(j,k)=qsm1(nc)
      qkc_g(j,k)=qkc1(nc)
      qm_g(j,k)=qm1(nc)
      xkm_m_g(j,k)=xkm1(nc)
      shear_mod_el_g(j,k)=xnw1(nc)
      struc_g(j,k)=0.5d0*(1.d0+1.d0/phi1(nc))
c Para compatibilizar con Carcione:
      struc_g(j,k)=1.d0
      enddo
      else
c Estoy en la capa inferior
      do j=0,ngx+1
      kf_g(j,k)=kf2(-nc)
      rhof_g(j,k)=rof2(-nc)
      muf_g(j,k)=muf2(-nc)
      xks_g(j,k)=xks2(-nc)
      ros_g(j,k)=ros2(-nc)
      fi_g(j,k)=phi2(-nc)
      kperm_g(j,k)=perm2(-nc)
      qsm_g(j,k)=qsm2(-nc)
      qkc_g(j,k)=qkc2(-nc)
      qm_g(j,k)=qm2(-nc)
      xkm_m_g(j,k)=xkm2(-nc)
      shear_mod_el_g(j,k)=xnw2(-nc)
      struc_g(j,k)=0.5d0*(1.d0+1.d0/phi2(-nc))
c Para compatibilizar con Carcione:
      struc_g(j,k)=1.d0
      enddo
      endif
      enddo
      
      k=ngy+1
      nc=1
      do j=0,ngx+1 
      kf_g(j,k)=kf1(nc)
      rhof_g(j,k)=rof1(nc)
      muf_g(j,k)=muf1(nc)
      xks_g(j,k)=xks1(nc)
      ros_g(j,k)=ros1(nc)
      fi_g(j,k)=phi1(nc)
      kperm_g(j,k)=perm1(nc)
      qsm_g(j,k)=qsm1(nc)
      qkc_g(j,k)=qkc1(nc)
      qm_g(j,k)=qm1(nc)
      xkm_m_g(j,k)=xkm1(nc)
      shear_mod_el_g(j,k)=xnw1(nc)
      struc_g(j,k)=0.5d0*(1.d0+1.d0/phi1(nc))
c Para compatibilizar con Carcione:
      struc_g(j,k)=1.d0
      enddo

      k=0
      nc=vector(1)
      do j=0,ngx+1
        kf_g(j,k)=kf2(-nc)
      rhof_g(j,k)=rof2(-nc)
      muf_g(j,k)=muf2(-nc)
      xks_g(j,k)=xks2(-nc)
      ros_g(j,k)=ros2(-nc)
      fi_g(j,k)=phi2(-nc)
      kperm_g(j,k)=perm2(-nc)
      qsm_g(j,k)=qsm2(-nc)
      qkc_g(j,k)=qkc2(-nc)
      qm_g(j,k)=qm2(-nc)
      xkm_m_g(j,k)=xkm2(-nc)
      shear_mod_el_g(j,k)=xnw2(-nc)
      struc_g(j,k)=0.5d0*(1.d0+1.d0/phi2(-nc))
c Para compatibilizar con Carcione:
      struc_g(j,k)=1.d0
      enddo
      
*  writes global coef. matrices 
 
           do k=0,ngy+1	 
          do j=0,ngx+1

          write(85,99)kf_g(j,k)
          write(86,99)rhof_g(j,k)	  
          write(87,99)muf_g(j,k)
          write(88,99)xks_g(j,k)
          write(89,99)ros_g(j,k)
          write(90,99)fi_g(j,k)	  
          write(91,99)kperm_g(j,k)
          write(92,99)qsm_g(j,k)	  
          write(93,99)qkc_g(j,k)
          write(94,99)qm_g(j,k)	  
          write(95,99)xkm_m_g(j,k)
          write(78,*)j,k,xkm_m_g(j,k)
          write(96,99)shear_mod_el_g(j,k)		  
          write(97,99)struc_g(j,k)		  		  
 
	  enddo
    	  enddo 

99        format(e12.5)
      	        

 

 	          
      return
      end
			  
			  
			  
			  
